package de.pheerai.rcdbquery

import de.pheerai.rcdbquery.dataMappings.order.Order
import de.pheerai.rcdbquery.dataMappings.order.sortBy
import de.pheerai.rcdbquery.dataMappings.page.page
import de.pheerai.rcdbquery.dataMappings.searchTerm.searchTerm
import de.pheerai.rcdbquery.dataMappings.searchType.SearchType
import de.pheerai.rcdbquery.dataMappings.searchType.searchType
import de.pheerai.rcdbquery.dataMappings.vendor.Vendor.*
import de.pheerai.rcdbquery.dataMappings.vendor.vendors
import de.pheerai.rcdbquery.dsl.rcdbQuery

fun main() {
    println(generateNameQueryUrl())
    println(generatePageQueryUrl())
}

fun generateNameQueryUrl() = rcdbQuery {
    searchType(SearchType.COASTER)
    searchTerm("Dragon")
    vendors {
        VEKOMA()
        INTAMIN()
        MACK()
    }
    sortBy {
        Order.MANUFACTURER()
        Order.INVERSIONS()
    }
}

fun generatePageQueryUrl() = rcdbQuery {
    page(3)
    searchType(SearchType.COASTER)
    vendors {
        INTAMIN()
    }
}
