package de.pheerai.rcdbquery.dataMappings.category

import de.pheerai.rcdbquery.dataMappings.internal.RcdbParamOption
import de.pheerai.rcdbquery.dataMappings.internal.StringGeneratable

enum class Category(
    override val prettyName: String,
    override val fullName: String,
    override val paramValue: Long
) : RcdbParamOption<Long> {
    FOURTH_DIMENSION("4th Dimension", 24),
    BRAKEMAN("Brakeman", 290),
    BUILT_INHOUSE("Built In-House", 28),
    DARK_RIDE("Dark Ride", 74),
    DUAL_STATION("Dual Station", 147),
    ENCLOSED("Enclosed", 114),
    FLOORLESS("Floorless", 111),
    HYBRID("Hybrid", 219),
    INDOOR("Indoor", 113),
    MIRROR("Mirror", 27),
    MOEBIUS("Möbius", 108),
    ONBOARD_SOUND("Onboard Sound", 309),
    PENDULUM("Pendulum", 82),
    QUASI_MOEBIUS("Quasi Möbius", 37),
    ROCKING_CARS("Rocking Cars", 34),
    SCENIC_RAILWAY("Scenic Railway", 25),
    SHUTTLE("Shuttle", 115),
    SIDE_FRICTION("Side Friction", 106),
    SINGLE_RAIL("Single Rail", 41),
    SLIDING_STATION("Sliding Station", 26),
    SPINNING_CARS("Spinning Cars", 105),
    STACKED_STORAGE("Stacked Storage", 88),
    TURNTABLE_STATION("Turntable Station", 42),
    TWIN("Twin", 104),
    VIRTUAL_REALITY("Virtual Reality", 32),
    WATER_COASTER("Water Coaster", 103)
    ;

    constructor(name: String, paramValue: Long) : this(name, name, paramValue)

    companion object : StringGeneratable<Category> {
        override val paramKey = "ca"
        override fun of(input: String): Category? = when (input) {
            "4th Dimension" -> FOURTH_DIMENSION
            "Brakeman" -> BRAKEMAN
            "Built In-House" -> BUILT_INHOUSE
            "Dark Ride" -> DARK_RIDE
            "Dual Station" -> DUAL_STATION
            "Enclosed" -> ENCLOSED
            "Floorless" -> FLOORLESS
            "Hybrid" -> HYBRID
            "Indoor" -> INDOOR
            "Mirror" -> MIRROR
            "Möbius" -> MOEBIUS
            "Onboard Sound" -> ONBOARD_SOUND
            "Pendulum" -> PENDULUM
            "Quasi Möbius" -> QUASI_MOEBIUS
            "Rocking Cars" -> ROCKING_CARS
            "Scenic Railway" -> SCENIC_RAILWAY
            "Shuttle" -> SHUTTLE
            "Side Friction" -> SIDE_FRICTION
            "Single Rail" -> SINGLE_RAIL
            "Sliding Station" -> SLIDING_STATION
            "Spinning Cars" -> SPINNING_CARS
            "Stacked Storage" -> STACKED_STORAGE
            "Turntable Station" -> TURNTABLE_STATION
            "Twin" -> TWIN
            "Virtual Reality" -> VIRTUAL_REALITY
            "Water Coaster" -> WATER_COASTER
            else -> null
        }
    }
}
