package de.pheerai.rcdbquery.dataMappings.design

import de.pheerai.rcdbquery.dataMappings.internal.RcdbParamOption
import de.pheerai.rcdbquery.dataMappings.internal.StringGeneratable

enum class Design(
    override val prettyName: String,
    override val fullName: String,
    override val paramValue: Long
) : RcdbParamOption<Long> {
    SIT_DOWN("Sit Down", 6),
    INVERTED("Inverted", 5),
    SUSPENDED("Suspended", 8),
    WING("Wing", 67),
    FLYING("Flying", 4),
    STAND_UP("Stand Up", 7),
    BOBSLED("Bobsled", 3),
    PIPELINE("Pipeline", 73)
    ;

    constructor(name: String, paramValue: Long) : this(name, name, paramValue)

    companion object : StringGeneratable<Design> {
        override val paramKey = "de"
        override fun of(input: String): Design? = when (input) {
            "Sit Down" -> SIT_DOWN
            "Inverted" -> INVERTED
            "Suspended" -> SUSPENDED
            "Wing" -> WING
            "Flying" -> FLYING
            "Stand Up" -> STAND_UP
            "Bobsled" -> BOBSLED
            "Pipeline" -> PIPELINE
            else -> null
        }
    }
}
