package de.pheerai.rcdbquery.dataMappings.order

import de.pheerai.rcdbquery.dataMappings.internal.MultiParamBuilder

class OrderBuilder : MultiParamBuilder<Long, Order>() {
    override fun add(param: Order): OrderBuilder {
        super.add(param)
        return this
    }

    override fun addAll(items: Array<Order>): OrderBuilder {
        super.addAll(items)
        return this
    }

    override fun addAll(items: Collection<Order>): OrderBuilder {
        super.addAll(items)
        return this
    }

    override fun Order.invoke() = add(this)
    fun allRelevant() = this.addAll(Order.values().filter { it.relevantForAll })
}
