package de.pheerai.rcdbquery.dataMappings.searchType

import de.pheerai.rcdbquery.dataMappings.internal.ParamKey
import de.pheerai.rcdbquery.dataMappings.internal.RcdbParamOption

@Suppress("unused")
enum class SearchType(
    override val prettyName: String,
    override val fullName: String,
    override val paramValue: Long
) : RcdbParamOption<Long> {
    COASTER("Coaster", "Search for Roller Coaster", 2),
    AMUSEMENT_PARK("Amusement Parks", "Searh for an amusement park", 3),
    COMPANY("Company", "Search for company (manufacturer, engineering,...)", 12),
    PERSON("Person", "Search for a person (designer, engineer,...)", 13)
    ;

    companion object: ParamKey {
        override val paramKey = "ot"
    }
}
