package de.pheerai.rcdbquery.dataMappings.status

import de.pheerai.rcdbquery.dataMappings.internal.RcdbParamOption
import de.pheerai.rcdbquery.dataMappings.internal.StringGeneratable

@Suppress("unused")
enum class Status(
    override val prettyName: String,
    override val fullName: String,
    override val paramValue: Long
) : RcdbParamOption<Long> {
    SBNO("SBNO", 311),
    OPERATING("Operating", 93),
    UNDER_CONSTRUCTION("Under Construction", 310),
    STORED("Stored", "In Storage", 312),
    RELOCATED("Relocated", -1),
    ;

    constructor(name: String, paramId: Long) : this(name, name, paramId)

    companion object: StringGeneratable<Status> {
        override val paramKey = "st"

        override fun of(input: String) = when (input) {
            "SBNO" -> SBNO
            "Operating" -> OPERATING
            "Under Construction" -> UNDER_CONSTRUCTION
            "In Storage" -> STORED
            else -> null
        }
    }
}
