package de.pheerai.rcdbquery.dataMappings.thrill

import de.pheerai.rcdbquery.dataMappings.internal.RcdbParamOption
import de.pheerai.rcdbquery.dataMappings.internal.StringGeneratable

enum class Thrill(
    override val prettyName: String,
    override val fullName: String,
    override val paramValue: Long
) : RcdbParamOption<Long> {
    KIDDIE("Kiddie", 21),
    FAMILY("Family", 22),
    THRILL("Thrill", 23),
    EXTREME("Extreme", 20)
    ;

    constructor(name: String, paramValue: Long) : this(name, name, paramValue)

    companion object : StringGeneratable<Thrill> {
        override val paramKey = "sc"

        override fun of(input: String): Thrill? = when (input) {
            "Kiddie" -> KIDDIE
            "Family" -> FAMILY
            "Thrill" -> THRILL
            "Extreme" -> EXTREME
            else -> null
        }
    }
}
